<?php

/* * ********************************************************************
 *  Provisioning Module for NodePing. Custom developed.
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Bogusław Kotarski <boguslaw.ko@modulesgarden.com>
 */
if (!class_exists('MG_WHMCS_NodePing_Product')) {

    class MG_WHMCS_NodePing_Product {

        public $id;
        public $defaultConfig = array();
        protected $_tableName = 'mg_prodConfig';
        protected $_config    = null;

        /**
         * FUNCTION __construct
         * Construc object
         * @param int $id
         * @param array $params
         */
        public function __construct($id, array $params = array()) {
            foreach ($params as $k => $v)
                $this->$k = $v;
            $this->id = (int) $id;

        }

        /**
         * FUNCTION load
         * Load product config
         * @throws Exception
         */
        public function load() {
            $q   = mysql_safequery('SELECT * FROM tblproducts WHERE id = ' . (int) $this->id);
            $row = mysql_fetch_assoc($q);
            if (!empty($row)) {
                foreach ($row as $k => $v)
                    $this->$k = $v;
            } else {
                throw new Exception('No product to load');
            }

        }

        /**
         * FUNCTION setIdByServiceId
         * Set id by service ID
         * @param int $serviceid
         */
        public function setIdByServiceId($serviceid) {
            $q        = mysql_safequery('SELECT packageid FROM tblhosting WHERE id = ' . (int) $serviceid);
            $row      = mysql_fetch_assoc($q);
            $this->id = (int) $row['packageid'];

        }

        /**
         * FUNCTION update
         * Update values  of this product 
         * @param array $values
         * @return type
         */
        public function update(array $values) {
            $sets = array();
            foreach ($values as $k => $v) {
                $v      = is_numeric($v) ? $v : '"' . mysql_real_escape_string($v) . '"';
                $sets[] = $k . '=' . $v;
            }
            return mysql_safequery('UPDATE tblproducts SET ' . implode(',', $sets) . ' WHERE id = ' . (int) $this->id);

        }

        /**
         * FUNCTION hasConfigurableOptions
         * Is configurable Options for this product
         * @return boolean
         */
        public function hasConfigurableOptions() {
            $q = mysql_query_safe('SELECT * FROM tblproductconfiglinks WHERE pid = ?', array($this->id));
            return (bool) mysql_num_rows($q);

        }

        /**
         * FUNCTION hasAssignedServerGroup
         * Is assigned server group for this product
         * @return boolean
         */
        public function hasAssignedServerGroup() {
            $q   = mysql_query_safe('SELECT servergroup FROM tblproducts WHERE id = ?', array($this->id));
            $row = mysql_fetch_assoc($q);
            return isset($row['servergroup']) ? (int) $row['servergroup'] : false;

        }

        /**
         * FUNCTION getParams
         * Get server and this product params
         * @return array
         */
        public function getParams() {
            $result = mysql_query_safe("
                                                    SELECT
                                                        s.ipaddress AS serverip, s.hostname AS serverhostname, s.username AS serverusername, s.password AS serverpassword, s.secure AS serversecure,
                                                        s.accesshash AS serveraccesshash,
                                                           configoption1,configoption2,configoption3,configoption4,configoption5,configoption6,configoption7,configoption8,configoption9
                                                    FROM tblservers AS s
                                                    JOIN tblservergroupsrel AS sgr ON sgr.serverid = s.id
                                                    JOIN tblservergroups AS sg ON sgr.groupid = sg.id
                                                    JOIN tblproducts AS p ON p.servergroup = sg.id
                                                    WHERE p.id = ?
                                                    ORDER BY s.active DESC
                                                    LIMIT 1", array($this->id)
            );
            $row    = mysql_fetch_assoc($result);
            // old whmcs
            if (!empty($row)) {
                if (!function_exists('decrypt') && file_exists(ROOTDIR . DS . 'includes' . DS . 'functions.php'))
                    include_once ROOTDIR . DS . 'includes' . DS . 'functions.php';
                $row['serverpassword'] = decrypt($row['serverpassword']);
            }
            return $row;

        }

        /**
         * FUNCTION getConfig
         * Get config $name for this product
         * @param string $name
         * @return boolean
         */
        public function getConfig($name) {
            $this->loadConfig();
            return isset($this->_config[$name]) ? $this->_config[$name] : null;

        }

        /**
         * FUNCTION getKeyConfig
         * Get key config for this product
         * @param string $name
         * @return string|boolean
         */
        public function getKeyConfig($name) {
            $this->loadConfig();
            $option_key = array_search($this->_config[$name], $this->defaultConfig[$name]['options']);
            return isset($this->_config[$name]) ? $option_key : null;

        }

        /**
         * FUNCTION issetConfig
         * Is config $name
         * @param string $name
         * @return boolean
         */
        public function issetConfig($name) {
            $this->loadConfig();
            return isset($this->_config[$name]);

        }

        /**
         * FUNCTION loadConfig
         * LoadConfig from db
         * @return type
         */
        public function loadConfig() {
            if ($this->_config !== null)
                return $this->_config;

            $this->setupDbTable();
            $sql = 'SELECT * FROM ' . $this->_tableName . ' WHERE product_id = ' . (int) $this->id;
            $q   = mysql_safequery($sql);
            while ($row = mysql_fetch_assoc($q)) {
                $this->_config[$row['setting']] = $row['value'];
            }
            return $this->_config;

        }

        /**
         * FUNCTION saveConfig
         * Save config to db
         * @param string $name
         * @param sting $value
         * @return boolean
         */
        public function saveConfig($name, $value) {
            $this->setupDbTable();
            if (is_array($value))
                $value = json_encode($value);
            return mysql_safequery('INSERT INTO ' . $this->_tableName . '(setting,product_id,value) VALUES(?,?,?) ON DUPLICATE KEY UPDATE value = ?', array(
                $name,
                (int) $this->id,
                $value,
                $value
            ));

        }

        /**
         * FUNCTION clearConfig
         * Clear config for this product
         * @return boolean
         */
        public function clearConfig() {
            return mysql_safequery('DELETE FROM ' . $this->_tableName . ' WHERE product_id = ' . (int) $this->id);

        }

        /**
         * FUNCTION renderConfigOptions
         * render Config Options
         * @param string $scripts
         * @return string
         */
        public function renderConfigOptions($scripts = '', $moduleWikiUrl = 'http://www.docs.modulesgarden.com/Main_Page', $moduleVersion = '1.0.0', $moduleLogoSrc = '') {


            $scripts .= '
				<style type="text/css">
				td.configoption_group {background-color:silver;font-weight:bold;text-align:left;}
				.fieldlabel.mg, .fieldarea.mg {width:25%;}
				.fielddescription {font-size: 10px;color: gray;display: inline;}
				</style>
			';
            $str     = '';
            $options = array();
            $groups  = array();
            $i       = 0;

            foreach ($this->defaultConfig as $k => $config) {
                // group html
                if (is_string($config)) {
                    $groups[$i] = $config;
                    continue;
                }
                if (isset($config['alt'])) {
                    if ($config['alt']) {
                        $config['description'] = '<img src="../images/help.gif" title="' . $config['alt'] . '"> ' . $config['description'];
                    }
                }

                $options[] = '
					<td class="fieldlabel mg">' . $config['title'] . '</td>
					<td class="fieldarea mg">
						' . $this->renderConfigOptionInput(
                                $k, $config['type'], isset($config['default']) ? $config['default'] : '', isset($config['options']) ? $config['options'] : array(), isset($config['useOptionsKeys']) && $config['useOptionsKeys']
                        ) . ($i == 0 ? $scripts : '') . '
						' . (isset($config['description']) ? '<div class="fielddescription">' . $config['description'] . '</div>' : '') . '
					</td>';
                $i++;
            }

            $countFields = 0;
            foreach ($options as $k => $option) {
                if ($countFields == 0 && $k != 0)
                    $str .= '<tr>';

                if (isset($groups[$k])) {
                    if ($countFields == 1)
                        $str .= '<td></td><td></td>';
                    $str .= '</tr><tr><td colspan="4" class="configoption_group">' . $groups[$k] . '</td></tr><tr>';
                    $countFields = 0;
                }
                $str .= $option;

                $countFields++;
                if ($countFields == 2)
                    $str .= '</tr>';
                if ($countFields > 1)
                    $countFields = 0;
            }
            if ($countFields != 0)
                $str .= '</tr>';
            return $str;

        }

        /**
         * FUNCTION renderConfigOptionInput
         * Render config option input
         * @param string $name
         * @param string $type
         * @param string $default
         * @param array $options
         * @return string
         * @throws Exception NO CHECKBOX
         */
        public function renderConfigOptionInput($name, $type, $default, $options, $optionsValuesFromKeys = false) {
            if ($this->getConfig($name) != null) {
                $value = $this->getConfig($name);
            } else {
                $value = $default;
            }
            switch ($type) {

                case 'multiselect':
                    $value = json_decode($value, true);
                    $str   = '<select name="customconfigoption[' . $name . '][]" multiple style="width:153px;">';
                    foreach ($options as $k => $option) {
                        $str .= '<option value="' . ($optionsValuesFromKeys ? $k : $option) . '" ' . (is_array($value) && in_array(($optionsValuesFromKeys ? $k : $option), $value) ? 'selected' : '') . '>' . $option . '</option>';
                    }
                    $str .= '</select>';
                    return $str;

                case 'select':
                    $str = '<select name="customconfigoption[' . $name . ']" style="width:160px;" ' . ($name == 'COS Name' ? 'id="onCOSChange"' : '') . '>';
                    foreach ($options as $key => $option) {
                        $str .= '<option value="' . $key . '" ' . (($value == $key) ? 'selected' : '') . '>' . $option . '</option>';
                    }

                    $str .= '</select>';
                    return $str;

                case 'text':
                    return '<input type="text" name="customconfigoption[' . $name . ']" value="' . $value . '" style="width:153px;" />';

                case 'textarea':
                    return '<textarea name="customconfigoption[' . $name . ']" style="width:153px;">' . $value . '</textarea>';

                case 'radio':
                    $str = '';
                    foreach ($options as $option)
                        $str .= '<input type="radio" name="customconfigoption[' . $name . ']" value="' . $option . '" /> ' . $option;
                    return $str;
                case 'checkbox':
                    return '<input class="hideOnChosenCOS" type="checkbox" name="customconfigoption[' . $name . ']" ' . ($value ? "checked" : "") . ' />';
                case 'html':
                    return '';
            }
            // YES CHECKBOX
            throw new Exception('Config Option type not supported');

        }

        /**
         * FUNCTION setupDbTable
         * setup Db Table
         * @return type
         */
        public function setupDbTable() {
            return mysql_query('CREATE TABLE IF NOT EXISTS `' . $this->_tableName . '` (
				`setting` varchar(100) NOT NULL,
				`product_id` int(10) unsigned NOT NULL,
				`value` varchar(250) NOT NULL,
				PRIMARY KEY (`setting`,`product_id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8;');

        }

    }

}
