{**********************************************************************
* Provisioning Module for NodePing. Custom developed.
* *
*
* CREATED BY MODULESGARDEN -> http://modulesgarden.com
* CONTACT -> contact@modulesgarden.com
*
*
*
*
* This software is furnished under a license and may be used and copied
* only in accordance with the terms of such license and with the
* inclusion of the above copyright notice. This software or any other
* copies thereof may not be provided or otherwise made available to any
* other person. No title to and ownership of the software is hereby
* transferred.
*
*
**********************************************************************}


<div class="module-header">
    <i class="icon-header icon-emails"></i>
    <h1>{$lang.checks.title}</h1>
    <p>{$lang.checks.descritpion}</p>
</div>
<div class="module-body">

    <div class="section">
        {foreach from=$plugins item=plugin}
            {$plugin.checks.html}
        {/foreach}
        <div class="help-block">{$lang.checks.usage} {$POST.checksCount}/{$POST.checksLimit}</div>
        <div class="progress">
            <div class="progress-bar progress-bar-success" role="progressbar " aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: {$POST.checksPercentage}%;"></div>
        </div>

        <div class="table-header">

            <div class="header-title">
                <h4>{$lang.checks.checks}</h4>
            </div>

            
            <div class="header-actions">
                <div class="header-search">
                    <div class="input-icon">
                        <i class="fa fa-search"></i>
                        <input class="form-control" type="text" placeholder="{$lang.checks.search}" data-search="alias-table">
                    </div>
                </div>


                {foreach from=$plugins item=plugin}
                    {if $plugin.htmlfilter}
                        <div class="header-filter" style="float:right;margin-right:5px;">
                            <select class="form-control" id="monitor-filter">
                                <option value="">All Monitors</option>
                                {foreach from=$plugin.htmlfilter item=filter}
                                    <option value="{$filter.value}">{$filter.text}</option>
                                {/foreach}
                            </select>
                        </div>
                    {/if}
                {/foreach}
                
            </div>

        </div>

        <table class="table" id="alias-table" >
            <thead>
                <tr>
                    
                    <th>{$lang.checks.type}</th>                    
                    <th>{$lang.checks.label}</th>
                    <th>{$lang.checks.interval}</th>
                    <th>{$lang.checks.status}</th>
                    {foreach from=$plugins item=plugin}
                        {$plugin.checks.table.header}
                    {/foreach}
                    <th width="50%">{$lang.checks.action}</th>
                </tr>
            </thead>
            <tbody>
                {if empty($checks)}
                    <tr><td colspan="6" style="text-align: center; color: gray;">{$lang.checks.nochecks}</td></tr>
                    {else}
                        {foreach from=$checks item="check"}
                        {assign var="found" value="0"}
                        <tr>
                            <td data-label="{$lang.aliases.account}" class="cell-sm-12">{$check.type}</td>
                            <td data-label="{$lang.aliases.alias}" class="cell-sm-12">
                                {$check.label}
                                {foreach from=$plugins item=plugin}
                                    {if $plugin.htmlfilter && ($check.type != 'Resource Monitor')}
                                        <span style="display:none;">Uptime</span>
                                    {/if}
                                {/foreach}

                            </td>
                            <td data-label="{$lang.aliases.alias}" class="cell-sm-12">{$check.interval}</td>
                            <td data-label="{$lang.aliases.alias}" class="cell-sm-12"><b>{$check.status}</b></td>
                            {foreach from=$plugins item=plugin}
                                {if count($responders)}

                                    {foreach from=$responders item=responder}
                                        {if $responder->checkid eq $check.id}
                                            {$plugin.checks.table.rows.found}
                                            {assign var="found" value="1"}
                                        {/if}
                                    {/foreach}
                                    {if $found eq 0}
                                        {$plugin.checks.table.rows.notfound}
                                    {/if}
                                {else}
                                    {$plugin.checks.table.rows.notfound}
                                {/if}
                            {/foreach}

                            <td data-label="{$lang.aliases.alias}" class="cell-sm-12">
                                <button type="button" onclick="window.location.href = '{$link}&page=reports&checkid={$check.id}'" class="btn btn-info">{$lang.checks.reports}</button>
                 
                                <button type="button" onclick="window.location.href = '{$link}&page=history&checkid={$check.id}'" class="btn btn-info">{$lang.checks.history}</button>
                                <button type="button" onclick="window.location.href = '{$link}&page=check&todo=edit&checkid={$check.id}&type={$check.type}'" class="btn btn-success">{$lang.checks.edit}</button>
                                <button type="button" onclick="
                                        {literal}
                                                if (confirm('{/literal}{$lang.checks.confirm}{literal}')) {
                                                    window.location.href = '{/literal}{$link}{literal}&page=checks&todo=delete&checkid={/literal}{$check.id}{literal}';
                                                            } else {
                                                                return false;
                                                            }
                                        {/literal}" class="btn btn-danger">{$lang.checks.delete}</button>
                            </td>
                        </tr>
                    {/foreach}
                {/if}
            </tbody>
        </table>
        {*      <input type="submit" value="{$lang.aliases.delete}" class="btn btn-danger">*}
    </div>


    {if $POST.checksCanAdd}
        <div class="section" style="margin-bottom: 40px">
            <button type="button" onclick="window.location.href = '{$link}&page=check&todo=new&type={$POST.newCheck}'" class="btn btn-success">{$lang.checks.add}</button>
        </div>
    {else}
        <div class="section" style="margin-bottom: 40px">
            {if count($plugins) }
                {foreach from=$plugins item=plugin}
                    {$plugin.checks.upgrade.html}
                {/foreach}
            {else}
                <button type="button" class="btn btn-danger">{$lang.checks.deined}</button>
            {/if}
        </div>
    {/if}



</div>
